#include "LinearAlgebra/Spherical.h"
#include "LinearAlgebra/SwingTwist.h"

namespace Passer {
namespace RoboidControl {

class LowLevelMessages {
public:
  static void SendAngle8(char *buffer, unsigned char *ix, const float angle);
  static Angle8 ReceiveAngle8(const char *buffer, unsigned char *startIndex);

  static void SendFloat16(char *buffer, unsigned char *ix, float value);
  static float ReceiveFloat16(const char *buffer, unsigned char *startIndex);

  static void SendSpherical16(char *buffer, unsigned char *ix, Spherical16 s);
  static Spherical16 ReceiveSpherical16(const char *buffer,
                                        unsigned char *startIndex);

  static void SendQuat32(char *buffer, unsigned char *ix, SwingTwist16 q);
  static SwingTwist16 ReceiveQuat32(const char *buffer, unsigned char *ix);
};

} // namespace RoboidControl
} // namespace Passer
using namespace Passer::RoboidControl;