#include "Messages.h"

namespace Passer {
namespace RoboidControl {

/// @brief Message for communicating the URL for a model of the thing
class ModelUrlMsg : public IMessage {
public:
  /// @brief The message ID
  static const unsigned char id = 0x90;
  /// @brief The length of the message without the URL string itself
  static const unsigned char length = 3;

  /// @brief The network ID of the thing
  unsigned char networkId;
  /// @brief The ID of the thing
  unsigned char thingId;
  
  /// @brief The length of the url st5ring, excluding the null terminator
  unsigned char urlLength;
  /// @brief The url of the model, not terminated by a null character
  const char *url;

  /// @brief Create a new message for sending
  /// @param networkId The network ID of the thing
  /// @param thing The thing for which to send the mode URL
  ModelUrlMsg(unsigned char networkId, Thing *thing);
  /// @copydoc Passer::RoboidControl::IMessage::IMessage(char*)
  ModelUrlMsg(const char *buffer);
  //   ModelUrlMsg(unsigned char networkId, unsigned char thingId,
  //               unsigned char urlLegth, const char *url, float scale = 1);
  
  /// @brief Destructor for the message
  virtual ~ModelUrlMsg();

  /// @copydoc Passer::RoboidControl::IMessage::Serialize
  virtual unsigned char Serialize(char *buffer) override;
};

} // namespace Control
} // namespace Passer